%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

Name:           ocaml-iostream
Version:        0.3
Release:        %mkrel 1
Summary:        Generic composable IO input and output streams for OCAML
Group:          Development/OCaml
License:        MIT

URL:            https://github.com/c-cube/ocaml-iostream
Source0:        %{url}/releases/download/v%{version}/iostream-%{version}.tbz

BuildRequires:  ocaml
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-camlzip-devel


%description
This library defines generic I/O streams of bytes. The streams should be
composable, user-definable, and agnostic to the underlying I/O mechanism; with
OCaml 5 it means that they might be backed by an effect-based scheduler.

The goal is to provide a reasonable interoperability layer that multiple
libraries and applications in the OCaml ecosystem can rely on, while providing
the modularity that standard IO channels lack. Modern statically typed
languages like Go and Rust provide this layer in their stdlib and their whole
ecosystem can build on it.


%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}


%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.


%package        camlzip
Summary:        Generic composable IO input and output streams for OCAML
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}


%description    camlzip
This library defines generic I/O streams of bytes. The streams should be
composable, user-definable, and agnostic to the underlying I/O mechanism; with
OCaml 5 it means that they might be backed by an effect-based scheduler.

The goal is to provide a reasonable interoperability layer that multiple
libraries and applications in the OCaml ecosystem can rely on, while providing
the modularity that standard IO channels lack. Modern statically typed
languages like Go and Rust provide this layer in their stdlib and their whole
ecosystem can build on it.

%package        camlzip-devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{version}-%{release}


%description    camlzip-devel
The %{name}-camlzip-devel package contains libraries and signature files for
developing applications that use %{name}.


%prep
%autosetup -p1 -n iostream-%{version}


%build
%dune_build


%install
%dune_install -s


%files -f .ofiles-iostream
%doc CHANGES.md README.md


%files devel -f .ofiles-iostream-devel


%files camlzip -f .ofiles-iostream-camlzip
%doc CHANGES.md README.md


%files camlzip-devel -f .ofiles-iostream-camlzip-devel


%changelog
* Sun Jun 22 2025 daviddavid <daviddavid> 0.3-1.mga10
+ Revision: 2193958
- initial package ocaml-iostream

